echo:
	subq	$24, %rsp   // allocate 4 bytes for buf, plus stack alignment
	movq	%fs:40, %rax  // load canary (%fs:40 set up by kernel)
	movq	%rax, 8(%rsp) // install canary on stack
	xorl	%eax, %eax    // %rax = 0  (hide canary from callee)
	movq	%rsp, %rdi    // %rdi = &buf
	call	gets          // gets(buf)  (same old insecure version)
	movq	%rsp, %rdi    // %rd = &buf
	call	puts          // puts(buf)
	movq	8(%rsp), %rax // load canary position from stack
	xorq	%fs:40, %rax  // compare to true value
	je	.L2           // if not equal, call __stack_chk_fail to abort
	call	__stack_chk_fail
.L2: // canary compared equal
	addq	$24, %rsp     // restore stack pointer
	ret

	subq	$24, %rsp   // allocate 4 bytes for buf, plus stack alignment
	movq	%rsp, %rdi  // %rdi = &buf
	call	gets        // gets(&buf)
	movq	%rsp, %rdi  // %rdi = &buf
	call	puts        // puts(&buf)
	addq	$24, %rsp   // restore stack pointer
	ret

call_echo:
	subq	$8, %rsp    // adjust stack alignment for function call
	call	echo        // just as it says
	addq	$8, %rsp    // restore stack pointer
	ret

.LC0:
	.string	"Okay, done."

main:
	subq	$8, %rspA   // adjust stack alignment for function call
	call	call_echo   // just as it says
	movl	$.LC0, %edi // %edi = (pointer to) "Okay, done."
	call	puts        // puts("Okay, done.")
	movl	$0, %eax    // retval = 0
	addq	$8, %rsp    // restore stack pointer
	ret
